package cn.superdesk.uniorder.dao.entity.invoice.common;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class InvoiceTypeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public InvoiceTypeExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
    invoice_type
     *
     * @mbg.generated Sun Apr 24 17:17:53 CST 2022
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNull() {
            addCriterion("type_name is null");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNotNull() {
            addCriterion("type_name is not null");
            return (Criteria) this;
        }

        public Criteria andTypeNameEqualTo(String value) {
            addCriterion("type_name =", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotEqualTo(String value) {
            addCriterion("type_name <>", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThan(String value) {
            addCriterion("type_name >", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("type_name >=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThan(String value) {
            addCriterion("type_name <", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThanOrEqualTo(String value) {
            addCriterion("type_name <=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLike(String value) {
            addCriterion("type_name like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotLike(String value) {
            addCriterion("type_name not like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameIn(List<String> values) {
            addCriterion("type_name in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotIn(List<String> values) {
            addCriterion("type_name not in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameBetween(String value1, String value2) {
            addCriterion("type_name between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotBetween(String value1, String value2) {
            addCriterion("type_name not between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameIsNull() {
            addCriterion("tax_bureau_invoice_type_name is null");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameIsNotNull() {
            addCriterion("tax_bureau_invoice_type_name is not null");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameEqualTo(String value) {
            addCriterion("tax_bureau_invoice_type_name =", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameNotEqualTo(String value) {
            addCriterion("tax_bureau_invoice_type_name <>", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameGreaterThan(String value) {
            addCriterion("tax_bureau_invoice_type_name >", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("tax_bureau_invoice_type_name >=", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameLessThan(String value) {
            addCriterion("tax_bureau_invoice_type_name <", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameLessThanOrEqualTo(String value) {
            addCriterion("tax_bureau_invoice_type_name <=", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameLike(String value) {
            addCriterion("tax_bureau_invoice_type_name like", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameNotLike(String value) {
            addCriterion("tax_bureau_invoice_type_name not like", value, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameIn(List<String> values) {
            addCriterion("tax_bureau_invoice_type_name in", values, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameNotIn(List<String> values) {
            addCriterion("tax_bureau_invoice_type_name not in", values, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameBetween(String value1, String value2) {
            addCriterion("tax_bureau_invoice_type_name between", value1, value2, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andTaxBureauInvoiceTypeNameNotBetween(String value1, String value2) {
            addCriterion("tax_bureau_invoice_type_name not between", value1, value2, "taxBureauInvoiceTypeName");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableIsNull() {
            addCriterion("customer_goods_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableIsNotNull() {
            addCriterion("customer_goods_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableEqualTo(Integer value) {
            addCriterion("customer_goods_enable =", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableNotEqualTo(Integer value) {
            addCriterion("customer_goods_enable <>", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableGreaterThan(Integer value) {
            addCriterion("customer_goods_enable >", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_enable >=", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableLessThan(Integer value) {
            addCriterion("customer_goods_enable <", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_enable <=", value, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableIn(List<Integer> values) {
            addCriterion("customer_goods_enable in", values, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableNotIn(List<Integer> values) {
            addCriterion("customer_goods_enable not in", values, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_enable between", value1, value2, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_enable not between", value1, value2, "customerGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableIsNull() {
            addCriterion("customer_credit_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableIsNotNull() {
            addCriterion("customer_credit_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableEqualTo(Integer value) {
            addCriterion("customer_credit_enable =", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableNotEqualTo(Integer value) {
            addCriterion("customer_credit_enable <>", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableGreaterThan(Integer value) {
            addCriterion("customer_credit_enable >", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_enable >=", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableLessThan(Integer value) {
            addCriterion("customer_credit_enable <", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_enable <=", value, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableIn(List<Integer> values) {
            addCriterion("customer_credit_enable in", values, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableNotIn(List<Integer> values) {
            addCriterion("customer_credit_enable not in", values, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_enable between", value1, value2, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_enable not between", value1, value2, "customerCreditEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableIsNull() {
            addCriterion("supplier_goods_enable is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableIsNotNull() {
            addCriterion("supplier_goods_enable is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableEqualTo(Integer value) {
            addCriterion("supplier_goods_enable =", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableNotEqualTo(Integer value) {
            addCriterion("supplier_goods_enable <>", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableGreaterThan(Integer value) {
            addCriterion("supplier_goods_enable >", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_enable >=", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableLessThan(Integer value) {
            addCriterion("supplier_goods_enable <", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableLessThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_enable <=", value, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableIn(List<Integer> values) {
            addCriterion("supplier_goods_enable in", values, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableNotIn(List<Integer> values) {
            addCriterion("supplier_goods_enable not in", values, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_enable between", value1, value2, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_enable not between", value1, value2, "supplierGoodsEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableIsNull() {
            addCriterion("customer_goods_mode_off_line_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableIsNotNull() {
            addCriterion("customer_goods_mode_off_line_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableEqualTo(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable =", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableNotEqualTo(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable <>", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableGreaterThan(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable >", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable >=", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableLessThan(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable <", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_off_line_enable <=", value, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableIn(List<Integer> values) {
            addCriterion("customer_goods_mode_off_line_enable in", values, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableNotIn(List<Integer> values) {
            addCriterion("customer_goods_mode_off_line_enable not in", values, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_off_line_enable between", value1, value2, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeOffLineEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_off_line_enable not between", value1, value2, "customerGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableIsNull() {
            addCriterion("customer_credit_mode_off_line_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableIsNotNull() {
            addCriterion("customer_credit_mode_off_line_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableEqualTo(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable =", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableNotEqualTo(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable <>", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableGreaterThan(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable >", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable >=", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableLessThan(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable <", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_off_line_enable <=", value, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableIn(List<Integer> values) {
            addCriterion("customer_credit_mode_off_line_enable in", values, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableNotIn(List<Integer> values) {
            addCriterion("customer_credit_mode_off_line_enable not in", values, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_off_line_enable between", value1, value2, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeOffLineEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_off_line_enable not between", value1, value2, "customerCreditModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableIsNull() {
            addCriterion("supplier_goods_mode_off_line_enable is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableIsNotNull() {
            addCriterion("supplier_goods_mode_off_line_enable is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable =", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableNotEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable <>", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableGreaterThan(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable >", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable >=", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableLessThan(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable <", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableLessThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_off_line_enable <=", value, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_off_line_enable in", values, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableNotIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_off_line_enable not in", values, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_off_line_enable between", value1, value2, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeOffLineEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_off_line_enable not between", value1, value2, "supplierGoodsModeOffLineEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableIsNull() {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableIsNotNull() {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable =", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable <>", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableGreaterThan(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable >", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable >=", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableLessThan(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable <", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable <=", value, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableIn(List<Integer> values) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable in", values, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable not in", values, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable between", value1, value2, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxElectronicInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_szhtxx_electronic_invoice_enable not between", value1, value2, "customerGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableIsNull() {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableIsNotNull() {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable =", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable <>", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableGreaterThan(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable >", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable >=", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableLessThan(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable <", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable <=", value, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableIn(List<Integer> values) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable in", values, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable not in", values, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable between", value1, value2, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxElectronicInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_szhtxx_electronic_invoice_enable not between", value1, value2, "customerCreditModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableIsNull() {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableIsNotNull() {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable =", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable <>", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableGreaterThan(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable >", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable >=", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableLessThan(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable <", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable <=", value, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable in", values, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable not in", values, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable between", value1, value2, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxElectronicInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_szhtxx_electronic_invoice_enable not between", value1, value2, "supplierGoodsModeSzhtxxElectronicInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultIsNull() {
            addCriterion("customer_goods_is_default is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultIsNotNull() {
            addCriterion("customer_goods_is_default is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultEqualTo(Integer value) {
            addCriterion("customer_goods_is_default =", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultNotEqualTo(Integer value) {
            addCriterion("customer_goods_is_default <>", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultGreaterThan(Integer value) {
            addCriterion("customer_goods_is_default >", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_is_default >=", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultLessThan(Integer value) {
            addCriterion("customer_goods_is_default <", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultLessThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_is_default <=", value, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultIn(List<Integer> values) {
            addCriterion("customer_goods_is_default in", values, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultNotIn(List<Integer> values) {
            addCriterion("customer_goods_is_default not in", values, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_is_default between", value1, value2, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsIsDefaultNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_is_default not between", value1, value2, "customerGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultIsNull() {
            addCriterion("customer_credit_is_default is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultIsNotNull() {
            addCriterion("customer_credit_is_default is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultEqualTo(Integer value) {
            addCriterion("customer_credit_is_default =", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultNotEqualTo(Integer value) {
            addCriterion("customer_credit_is_default <>", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultGreaterThan(Integer value) {
            addCriterion("customer_credit_is_default >", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_is_default >=", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultLessThan(Integer value) {
            addCriterion("customer_credit_is_default <", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultLessThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_is_default <=", value, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultIn(List<Integer> values) {
            addCriterion("customer_credit_is_default in", values, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultNotIn(List<Integer> values) {
            addCriterion("customer_credit_is_default not in", values, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_is_default between", value1, value2, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditIsDefaultNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_is_default not between", value1, value2, "customerCreditIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultIsNull() {
            addCriterion("supplier_goods_is_default is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultIsNotNull() {
            addCriterion("supplier_goods_is_default is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultEqualTo(Integer value) {
            addCriterion("supplier_goods_is_default =", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultNotEqualTo(Integer value) {
            addCriterion("supplier_goods_is_default <>", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultGreaterThan(Integer value) {
            addCriterion("supplier_goods_is_default >", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_is_default >=", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultLessThan(Integer value) {
            addCriterion("supplier_goods_is_default <", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultLessThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_is_default <=", value, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultIn(List<Integer> values) {
            addCriterion("supplier_goods_is_default in", values, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultNotIn(List<Integer> values) {
            addCriterion("supplier_goods_is_default not in", values, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_is_default between", value1, value2, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsIsDefaultNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_is_default not between", value1, value2, "supplierGoodsIsDefault");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableIsNull() {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableIsNotNull() {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable =", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable <>", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableGreaterThan(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable >", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable >=", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableLessThan(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable <", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable <=", value, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableIn(List<Integer> values) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable in", values, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable not in", values, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable between", value1, value2, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsModeSzhtxxPaperInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_goods_mode_szhtxx_paper_invoice_enable not between", value1, value2, "customerGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableIsNull() {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableIsNotNull() {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable =", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable <>", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableGreaterThan(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable >", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable >=", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableLessThan(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable <", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable <=", value, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableIn(List<Integer> values) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable in", values, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable not in", values, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable between", value1, value2, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditModeSzhtxxPaperInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("customer_credit_mode_szhtxx_paper_invoice_enable not between", value1, value2, "customerCreditModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableIsNull() {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableIsNotNull() {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable =", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableNotEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable <>", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableGreaterThan(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable >", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable >=", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableLessThan(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable <", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableLessThanOrEqualTo(Integer value) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable <=", value, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable in", values, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableNotIn(List<Integer> values) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable not in", values, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable between", value1, value2, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsModeSzhtxxPaperInvoiceEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier_goods_mode_szhtxx_paper_invoice_enable not between", value1, value2, "supplierGoodsModeSzhtxxPaperInvoiceEnable");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeIsNull() {
            addCriterion("customer_goods_update_time is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeIsNotNull() {
            addCriterion("customer_goods_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeEqualTo(Date value) {
            addCriterion("customer_goods_update_time =", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeNotEqualTo(Date value) {
            addCriterion("customer_goods_update_time <>", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeGreaterThan(Date value) {
            addCriterion("customer_goods_update_time >", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("customer_goods_update_time >=", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeLessThan(Date value) {
            addCriterion("customer_goods_update_time <", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("customer_goods_update_time <=", value, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeIn(List<Date> values) {
            addCriterion("customer_goods_update_time in", values, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeNotIn(List<Date> values) {
            addCriterion("customer_goods_update_time not in", values, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("customer_goods_update_time between", value1, value2, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("customer_goods_update_time not between", value1, value2, "customerGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeIsNull() {
            addCriterion("customer_credit_update_time is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeIsNotNull() {
            addCriterion("customer_credit_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeEqualTo(Date value) {
            addCriterion("customer_credit_update_time =", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeNotEqualTo(Date value) {
            addCriterion("customer_credit_update_time <>", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeGreaterThan(Date value) {
            addCriterion("customer_credit_update_time >", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("customer_credit_update_time >=", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeLessThan(Date value) {
            addCriterion("customer_credit_update_time <", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("customer_credit_update_time <=", value, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeIn(List<Date> values) {
            addCriterion("customer_credit_update_time in", values, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeNotIn(List<Date> values) {
            addCriterion("customer_credit_update_time not in", values, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("customer_credit_update_time between", value1, value2, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("customer_credit_update_time not between", value1, value2, "customerCreditUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeIsNull() {
            addCriterion("supplier_goods_update_time is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeIsNotNull() {
            addCriterion("supplier_goods_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeEqualTo(Date value) {
            addCriterion("supplier_goods_update_time =", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeNotEqualTo(Date value) {
            addCriterion("supplier_goods_update_time <>", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeGreaterThan(Date value) {
            addCriterion("supplier_goods_update_time >", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("supplier_goods_update_time >=", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeLessThan(Date value) {
            addCriterion("supplier_goods_update_time <", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("supplier_goods_update_time <=", value, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeIn(List<Date> values) {
            addCriterion("supplier_goods_update_time in", values, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeNotIn(List<Date> values) {
            addCriterion("supplier_goods_update_time not in", values, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("supplier_goods_update_time between", value1, value2, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("supplier_goods_update_time not between", value1, value2, "supplierGoodsUpdateTime");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdIsNull() {
            addCriterion("customer_goods_update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdIsNotNull() {
            addCriterion("customer_goods_update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdEqualTo(Long value) {
            addCriterion("customer_goods_update_user_id =", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdNotEqualTo(Long value) {
            addCriterion("customer_goods_update_user_id <>", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdGreaterThan(Long value) {
            addCriterion("customer_goods_update_user_id >", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("customer_goods_update_user_id >=", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdLessThan(Long value) {
            addCriterion("customer_goods_update_user_id <", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("customer_goods_update_user_id <=", value, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdIn(List<Long> values) {
            addCriterion("customer_goods_update_user_id in", values, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdNotIn(List<Long> values) {
            addCriterion("customer_goods_update_user_id not in", values, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("customer_goods_update_user_id between", value1, value2, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("customer_goods_update_user_id not between", value1, value2, "customerGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdIsNull() {
            addCriterion("customer_credit_update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdIsNotNull() {
            addCriterion("customer_credit_update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdEqualTo(Long value) {
            addCriterion("customer_credit_update_user_id =", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdNotEqualTo(Long value) {
            addCriterion("customer_credit_update_user_id <>", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdGreaterThan(Long value) {
            addCriterion("customer_credit_update_user_id >", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("customer_credit_update_user_id >=", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdLessThan(Long value) {
            addCriterion("customer_credit_update_user_id <", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("customer_credit_update_user_id <=", value, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdIn(List<Long> values) {
            addCriterion("customer_credit_update_user_id in", values, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdNotIn(List<Long> values) {
            addCriterion("customer_credit_update_user_id not in", values, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("customer_credit_update_user_id between", value1, value2, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("customer_credit_update_user_id not between", value1, value2, "customerCreditUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdIsNull() {
            addCriterion("supplier_goods_update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdIsNotNull() {
            addCriterion("supplier_goods_update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdEqualTo(Long value) {
            addCriterion("supplier_goods_update_user_id =", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdNotEqualTo(Long value) {
            addCriterion("supplier_goods_update_user_id <>", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdGreaterThan(Long value) {
            addCriterion("supplier_goods_update_user_id >", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("supplier_goods_update_user_id >=", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdLessThan(Long value) {
            addCriterion("supplier_goods_update_user_id <", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("supplier_goods_update_user_id <=", value, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdIn(List<Long> values) {
            addCriterion("supplier_goods_update_user_id in", values, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdNotIn(List<Long> values) {
            addCriterion("supplier_goods_update_user_id not in", values, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("supplier_goods_update_user_id between", value1, value2, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("supplier_goods_update_user_id not between", value1, value2, "supplierGoodsUpdateUserId");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameIsNull() {
            addCriterion("customer_goods_update_user_name is null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameIsNotNull() {
            addCriterion("customer_goods_update_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameEqualTo(String value) {
            addCriterion("customer_goods_update_user_name =", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameNotEqualTo(String value) {
            addCriterion("customer_goods_update_user_name <>", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameGreaterThan(String value) {
            addCriterion("customer_goods_update_user_name >", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("customer_goods_update_user_name >=", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameLessThan(String value) {
            addCriterion("customer_goods_update_user_name <", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameLessThanOrEqualTo(String value) {
            addCriterion("customer_goods_update_user_name <=", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameLike(String value) {
            addCriterion("customer_goods_update_user_name like", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameNotLike(String value) {
            addCriterion("customer_goods_update_user_name not like", value, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameIn(List<String> values) {
            addCriterion("customer_goods_update_user_name in", values, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameNotIn(List<String> values) {
            addCriterion("customer_goods_update_user_name not in", values, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameBetween(String value1, String value2) {
            addCriterion("customer_goods_update_user_name between", value1, value2, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerGoodsUpdateUserNameNotBetween(String value1, String value2) {
            addCriterion("customer_goods_update_user_name not between", value1, value2, "customerGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameIsNull() {
            addCriterion("customer_credit_update_user_name is null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameIsNotNull() {
            addCriterion("customer_credit_update_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameEqualTo(String value) {
            addCriterion("customer_credit_update_user_name =", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameNotEqualTo(String value) {
            addCriterion("customer_credit_update_user_name <>", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameGreaterThan(String value) {
            addCriterion("customer_credit_update_user_name >", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("customer_credit_update_user_name >=", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameLessThan(String value) {
            addCriterion("customer_credit_update_user_name <", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameLessThanOrEqualTo(String value) {
            addCriterion("customer_credit_update_user_name <=", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameLike(String value) {
            addCriterion("customer_credit_update_user_name like", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameNotLike(String value) {
            addCriterion("customer_credit_update_user_name not like", value, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameIn(List<String> values) {
            addCriterion("customer_credit_update_user_name in", values, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameNotIn(List<String> values) {
            addCriterion("customer_credit_update_user_name not in", values, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameBetween(String value1, String value2) {
            addCriterion("customer_credit_update_user_name between", value1, value2, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andCustomerCreditUpdateUserNameNotBetween(String value1, String value2) {
            addCriterion("customer_credit_update_user_name not between", value1, value2, "customerCreditUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameIsNull() {
            addCriterion("supplier_goods_update_user_name is null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameIsNotNull() {
            addCriterion("supplier_goods_update_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameEqualTo(String value) {
            addCriterion("supplier_goods_update_user_name =", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameNotEqualTo(String value) {
            addCriterion("supplier_goods_update_user_name <>", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameGreaterThan(String value) {
            addCriterion("supplier_goods_update_user_name >", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("supplier_goods_update_user_name >=", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameLessThan(String value) {
            addCriterion("supplier_goods_update_user_name <", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameLessThanOrEqualTo(String value) {
            addCriterion("supplier_goods_update_user_name <=", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameLike(String value) {
            addCriterion("supplier_goods_update_user_name like", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameNotLike(String value) {
            addCriterion("supplier_goods_update_user_name not like", value, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameIn(List<String> values) {
            addCriterion("supplier_goods_update_user_name in", values, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameNotIn(List<String> values) {
            addCriterion("supplier_goods_update_user_name not in", values, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameBetween(String value1, String value2) {
            addCriterion("supplier_goods_update_user_name between", value1, value2, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }

        public Criteria andSupplierGoodsUpdateUserNameNotBetween(String value1, String value2) {
            addCriterion("supplier_goods_update_user_name not between", value1, value2, "supplierGoodsUpdateUserName");
            return (Criteria) this;
        }
    }

    /**
    invoice_type
     *
     * @mbg.generated do_not_delete_during_merge Sun Apr 24 17:17:53 CST 2022
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
    invoice_type
     *
     * @mbg.generated Sun Apr 24 17:17:53 CST 2022
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}